Index: trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp
===================================================================
--- trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 253)
+++ trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 273)
@@ -3850,10 +4210,10 @@
     ///////////////////////////////////////////////////////////////////////////////////
 
-    switch ( r_sc_fsm.read() ) 
+    switch ( r_sc_fsm.read() )
     {
         /////////////
-        case SC_IDLE:	    // fill the local rdata buffers
-        {
-            if( m_cmd_sc_addr_fifo.rok() ) 
+        case SC_IDLE:     // fill the local rdata buffers
+        {
+            if( m_cmd_sc_addr_fifo.rok() )
             {
 
@@ -3862,6 +4222,6 @@
 {
     std::cout << "  <MEMC " << name() << ".SC_IDLE> SC command: " << std::hex
-              << " srcid = " <<  std::dec << m_cmd_sc_srcid_fifo.read() 
-              << " addr = " << std::hex << m_cmd_sc_addr_fifo.read() 
+              << " srcid = " <<  std::dec << m_cmd_sc_srcid_fifo.read()
+              << " addr = " << std::hex << m_cmd_sc_addr_fifo.read()
               << " wdata = " << m_cmd_sc_wdata_fifo.read()
               << " eop = " << std::dec << m_cmd_sc_eop_fifo.read()
@@ -3872,6 +4232,6 @@
                 {
                     m_cpt_sc++;
-                    r_sc_fsm = SC_DIR_LOCK;
-                } 
+                    r_sc_fsm = SC_DIR_REQ;
+                }
                 else  // we keep the last word in the FIFO
                 {
@@ -3887,5 +4247,5 @@
                 if( r_sc_cpt.read()>3 ) // more than 4 flits...
                 {
-                    std::cout << "VCI_MEM_CACHE ERROR in SC_IDLE state : illegal SC command" 
+                    std::cout << "VCI_MEM_CACHE ERROR in SC_IDLE state : illegal SC command"
                               << std::endl;
                     exit(0);
@@ -3896,11 +4256,31 @@
 
                 r_sc_cpt = r_sc_cpt.read()+1;
-            }	
+            }
             break;
         }
+        
+        /////////////////
+        case SC_DIR_REQ:
+        {
+            if( r_alloc_dir_fsm.read() == ALLOC_DIR_SC )
+            {
+              r_sc_fsm = SC_DIR_LOCK;
+            }
+
+#if DEBUG_MEMC_SC
+            if( m_debug_sc_fsm )
+            {
+              std::cout 
+                << "  <MEMC " << name() << ".SC_DIR_REQ> Requesting DIR lock "
+                << std::endl;
+            }
+#endif
+            break;
+        }
+
         /////////////////
         case SC_DIR_LOCK:  // Read the directory
         {
-            if( r_alloc_dir_fsm.read() == ALLOC_DIR_SC ) 
+            if( r_alloc_dir_fsm.read() == ALLOC_DIR_SC )
             {
                 size_t way = 0;
@@ -3919,6 +4299,6 @@
                 r_sc_count      = entry.count;
 
-                if ( entry.valid ) 	r_sc_fsm = SC_DIR_HIT_READ; 
-                else 			    r_sc_fsm = SC_MISS_TRT_LOCK;
+                if ( entry.valid )  r_sc_fsm = SC_DIR_HIT_READ;
+                else          r_sc_fsm = SC_MISS_TRT_LOCK;
 
 #if DEBUG_MEMC_SC
@@ -3927,5 +4307,5 @@
     std::cout << "  <MEMC " << name() << ".SC_DIR_LOCK> Directory acces"
               << " / address = " << std::hex << m_cmd_sc_addr_fifo.read()
-              << " / hit = " << std::dec << entry.valid 
+              << " / hit = " << std::dec << entry.valid
               << " / count = " << entry.count
               << " / is_cnt = " << entry.is_cnt << std::endl;
@@ -3933,4 +4313,14 @@
 #endif
             }
+            else
+            {
+              std::cout
+                << "VCI_MEM_CACHE ERROR " << name()
+                << " SC_DIR_LOCK state" << std::endl
+                << "Bad DIR allocation"   << std::endl;
+
+              exit(0);
+            }
+
             break;
         }
@@ -3939,15 +4329,15 @@
                                // and check data change in cache
         {
-            size_t way	= r_sc_way.read();
-            size_t set	= m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())]; 
-            size_t word	= m_x[(vci_addr_t)(m_cmd_sc_addr_fifo.read())]; 
+            size_t way  = r_sc_way.read();
+            size_t set  = m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
+            size_t word = m_x[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
 
             // update directory (lock & dirty bits)
             DirectoryEntry entry;
-            entry.valid	         = true;
+            entry.valid          = true;
             entry.is_cnt         = r_sc_is_cnt.read();
-            entry.dirty	         = true;
-            entry.lock	         = true;
-            entry.tag	         = r_sc_tag.read();
+            entry.dirty          = true;
+            entry.lock           = true;
+            entry.tag          = r_sc_tag.read();
             entry.owner.srcid    = r_sc_copy.read();
 #if L1_MULTI_CACHE
@@ -3965,9 +4355,9 @@
                 ok &= ( r_sc_rdata[1] == m_cache_data[way][set][word+1] );
 
-            // to avoid livelock, force the atomic access to fail pseudo-randomly 
+            // to avoid livelock, force the atomic access to fail pseudo-randomly
             bool forced_fail = ( (r_sc_lfsr % (64) == 0) && RANDOMIZE_SC );
             r_sc_lfsr = (r_sc_lfsr >> 1) ^ ((-(r_sc_lfsr & 1)) & 0xd0000001);
 
-            if( ok and not forced_fail )	// no data change
+            if( ok and not forced_fail )  // no data change
             {
                 r_sc_fsm = SC_DIR_HIT_WRITE;
@@ -3976,10 +4366,10 @@
             {
                 r_sc_fsm = SC_RSP_FAIL;
-            } 
+            }
 
 #if DEBUG_MEMC_SC
 if( m_debug_sc_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".SC_DIR_HIT_READ> Test if SC success:" 
+    std::cout << "  <MEMC " << name() << ".SC_DIR_HIT_READ> Test if SC success:"
               << " / expected value = " << r_sc_rdata[0].read()
               << " / actual value = " << m_cache_data[way][set][word]
@@ -3990,18 +4380,18 @@
         }
         //////////////////////
-        case SC_DIR_HIT_WRITE: 		// test if a CC transaction is required
+        case SC_DIR_HIT_WRITE:    // test if a CC transaction is required
                                     // write data in cache if no CC request
         {
             // test coherence request
-            if(r_sc_count.read())   // replicated line 
+            if(r_sc_count.read())   // replicated line
             {
                 if ( r_sc_is_cnt.read() )
                 {
-                    r_sc_fsm = SC_BC_TRT_LOCK; 		// broadcast invalidate required
+                    r_sc_fsm = SC_BC_TRT_LOCK;    // broadcast invalidate required
                 }
-                else if( !r_sc_to_init_cmd_multi_req.read() && 
+                else if( !r_sc_to_init_cmd_multi_req.read() &&
                          !r_sc_to_init_cmd_brdcast_req.read()  )
                 {
-                    r_sc_fsm = SC_UPT_LOCK;			// multi update required
+                    r_sc_fsm = SC_UPT_LOCK;     // multi update required
                 }
                 else
@@ -4009,10 +4399,10 @@
                     r_sc_fsm = SC_WAIT;
                 }
-            } 
-            else                    // no copies 
-            {
-                size_t way	= r_sc_way.read();
-                size_t set	= m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())]; 
-                size_t word	= m_x[(vci_addr_t)(m_cmd_sc_addr_fifo.read())]; 
+            }
+            else                    // no copies
+            {
+                size_t way  = r_sc_way.read();
+                size_t set  = m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
+                size_t word = m_x[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
 
                 // cache update
@@ -4022,9 +4412,9 @@
 
                 // monitor
-                if ( m_monitor_ok ) 
+                if ( m_monitor_ok )
                 {
                     vci_addr_t address = m_cmd_sc_addr_fifo.read();
-		            char buf[80];
-		            snprintf(buf, 80, "SC_DIR_HIT_WRITE srcid %d", m_cmd_sc_srcid_fifo.read());
+                char buf[80];
+                snprintf(buf, 80, "SC_DIR_HIT_WRITE srcid %d", m_cmd_sc_srcid_fifo.read());
                     check_monitor( buf, address, r_sc_wdata.read() );
                     if ( r_sc_cpt.read()==4 )
@@ -4036,5 +4426,5 @@
 if( m_debug_sc_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".SC_DIR_HIT_WRITE> Update cache:" 
+    std::cout << "  <MEMC " << name() << ".SC_DIR_HIT_WRITE> Update cache:"
               << " way = " << std::dec << way
               << " / set = " << set
@@ -4052,5 +4442,5 @@
                            // releases locks to retry later if UPT full
         {
-            if ( r_alloc_upt_fsm.read() == ALLOC_UPT_SC ) 
+            if ( r_alloc_upt_fsm.read() == ALLOC_UPT_SC )
             {
                 bool        wok        = false;
@@ -4059,8 +4449,8 @@
                 size_t      trdid      = m_cmd_sc_trdid_fifo.read();
                 size_t      pktid      = m_cmd_sc_pktid_fifo.read();
-                addr_t	    nline      = m_nline[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
+                addr_t      nline      = m_nline[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
                 size_t      nb_copies  = r_sc_count.read();
 
-                wok = m_update_tab.set(true,	// it's an update transaction
+                wok = m_update_tab.set(true,  // it's an update transaction
                                        false,   // it's not a broadcast
                                        true,    // it needs a response
@@ -4074,7 +4464,7 @@
                 {
                     // cache update
-                    size_t way	= r_sc_way.read();
-                    size_t set	= m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())]; 
-                    size_t word	= m_x[(vci_addr_t)(m_cmd_sc_addr_fifo.read())]; 
+                    size_t way  = r_sc_way.read();
+                    size_t set  = m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
+                    size_t word = m_x[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
 
                     m_cache_data[way][set][word] = r_sc_wdata.read();
@@ -4083,9 +4473,9 @@
 
                     // monitor
-                    if ( m_monitor_ok ) 
-                    { 
+                    if ( m_monitor_ok )
+                    {
                         vci_addr_t address = m_cmd_sc_addr_fifo.read();
-		                char buf[80];
-		                snprintf(buf, 80, "SC_DIR_HIT_WRITE srcid %d", m_cmd_sc_srcid_fifo.read());
+                    char buf[80];
+                    snprintf(buf, 80, "SC_DIR_HIT_WRITE srcid %d", m_cmd_sc_srcid_fifo.read());
                         check_monitor( buf, address, r_sc_wdata.read() );
                         if ( r_sc_cpt.read()==4 )
@@ -4104,7 +4494,7 @@
 if( m_debug_sc_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".SC_UPT_LOCK> Register multi-update transaction in UPT"  
+    std::cout << "  <MEMC " << name() << ".SC_UPT_LOCK> Register multi-update transaction in UPT"
               << " / wok = " << wok
-              << " / nline  = " << std::hex << nline 
+              << " / nline  = " << std::hex << nline
               << " / count = " << nb_copies << std::endl;
 }
@@ -4114,5 +4504,5 @@
         }
         /////////////
-        case SC_WAIT: 	// release all locks and retry from beginning
+        case SC_WAIT:   // release all locks and retry from beginning
         {
 
@@ -4123,11 +4513,11 @@
 }
 #endif
-            r_sc_fsm = SC_DIR_LOCK;
+            r_sc_fsm = SC_DIR_REQ;
             break;
         }
         //////////////////
-        case SC_UPT_HEAP_LOCK: 	// lock the heap
-        {
-            if( r_alloc_heap_fsm.read() == ALLOC_HEAP_SC ) 
+        case SC_UPT_HEAP_LOCK:  // lock the heap
+        {
+            if( r_alloc_heap_fsm.read() == ALLOC_HEAP_SC )
             {
 
@@ -4143,5 +4533,5 @@
         }
         ////////////////
-        case SC_UPT_REQ: 	// send a first update request to INIT_CMD FSM
+        case SC_UPT_REQ:  // send a first update request to INIT_CMD FSM
         {
             assert((r_alloc_heap_fsm.read() == ALLOC_HEAP_SC) and
@@ -4160,6 +4550,6 @@
                     r_sc_to_init_cmd_is_long    = true;
                     r_sc_to_init_cmd_wdata_high = m_cmd_sc_wdata_fifo.read();
-                } 
-                else 
+                }
+                else
                 {
                     r_sc_to_init_cmd_is_long    = false;
@@ -4181,6 +4571,6 @@
                     r_sc_to_init_cmd_multi_req = true;
                     r_sc_cpt = 0;
-                } 
-                else			// several copies
+                }
+                else      // several copies
                 {
                     r_sc_fsm = SC_UPT_NEXT;
@@ -4190,8 +4580,8 @@
 if( m_debug_sc_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".SC_UPT_REQ> Send the first update request to INIT_CMD FSM " 
+    std::cout << "  <MEMC " << name() << ".SC_UPT_REQ> Send the first update request to INIT_CMD FSM "
               << " / address = " << std::hex << m_cmd_sc_addr_fifo.read()
               << " / wdata = " << std::hex << r_sc_wdata.read()
-              << " / srcid = " << std::dec << r_sc_copy.read() 
+              << " / srcid = " << std::dec << r_sc_copy.read()
               << " / inst = " << std::dec << r_sc_copy_inst.read() << std::endl;
 }
@@ -4201,5 +4591,5 @@
         }
         /////////////////
-        case SC_UPT_NEXT:   	// send a multi-update request to INIT_CMD FSM
+        case SC_UPT_NEXT:     // send a multi-update request to INIT_CMD FSM
         {
             assert((r_alloc_heap_fsm.read() == ALLOC_HEAP_SC)
@@ -4224,11 +4614,11 @@
                     cmd_sc_fifo_get = true;
                     r_sc_cpt        = 0;
-                } 
-            } 
+                }
+            }
 
 #if DEBUG_MEMC_SC
 if( m_debug_sc_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".SC_UPT_NEXT> Send the next update request to INIT_CMD FSM " 
+    std::cout << "  <MEMC " << name() << ".SC_UPT_NEXT> Send the next update request to INIT_CMD FSM "
               << " / address = " << std::hex << m_cmd_sc_addr_fifo.read()
               << " / wdata = " << std::hex << r_sc_wdata.read()
@@ -4240,25 +4630,25 @@
         }
         /////////////////////
-        case SC_BC_TRT_LOCK:  		// check the TRT to register a PUT transaction     
-        {
-            if( r_alloc_trt_fsm.read() == ALLOC_TRT_SC ) 
+        case SC_BC_TRT_LOCK:      // check the TRT to register a PUT transaction
+        {
+            if( r_alloc_trt_fsm.read() == ALLOC_TRT_SC )
             {
                 if( !r_sc_to_ixr_cmd_req )  // we can transfer the request to IXR_CMD FSM
                 {
                     // fill the data buffer
-                    size_t way	= r_sc_way.read();
-                    size_t set	= m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
+                    size_t way  = r_sc_way.read();
+                    size_t set  = m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
                         size_t word = m_x[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
                     for(size_t i = 0; i<m_words; i++)
                     {
-                        if (i == word) 
+                        if (i == word)
                         {
                             r_sc_to_ixr_cmd_data[i] = r_sc_wdata.read();
-                        } 
+                        }
                         else if ( (i == word+1) && (r_sc_cpt.read()==4) ) // 64 bit SC
                         {
                             r_sc_to_ixr_cmd_data[i] = m_cmd_sc_wdata_fifo.read();
-                        } 
-                        else 
+                        }
+                        else
                         {
                             r_sc_to_ixr_cmd_data[i] = m_cache_data[way][set][i];
@@ -4267,15 +4657,15 @@
                     size_t wok_index = 0;
                     bool   wok       = !m_transaction_tab.full(wok_index);
-                    if ( wok )  
+                    if ( wok )
                     {
                         r_sc_trt_index = wok_index;
-                        r_sc_fsm       = SC_BC_UPT_LOCK; 
-                    } 
-                    else 
+                        r_sc_fsm       = SC_BC_UPT_LOCK;
+                    }
+                    else
                     {
                         r_sc_fsm       = SC_WAIT;
                     }
-                } 
-                else 
+                }
+                else
                 {
                     r_sc_fsm = SC_WAIT;
@@ -4288,5 +4678,5 @@
                               // write data in cache in case of successful registration
         {
-            if ( r_alloc_upt_fsm.read() == ALLOC_UPT_SC ) 
+            if ( r_alloc_upt_fsm.read() == ALLOC_UPT_SC )
             {
                 bool        wok       = false;
@@ -4295,9 +4685,9 @@
                 size_t      trdid     = m_cmd_sc_trdid_fifo.read();
                 size_t      pktid     = m_cmd_sc_pktid_fifo.read();
-                addr_t	    nline     = m_nline[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
+                addr_t      nline     = m_nline[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
                 size_t      nb_copies = r_sc_count.read();
 
                 // register a broadcast inval transaction in UPT
-                wok = m_update_tab.set(false,	// it's an inval transaction
+                wok = m_update_tab.set(false, // it's an inval transaction
                                        true,    // it's a broadcast
                                        true,    // it needs a response
@@ -4308,11 +4698,11 @@
                                        nb_copies,
                                        index);
-                
-                if ( wok )	// UPT not full
+
+                if ( wok )  // UPT not full
                 {
                     // cache update
-                    size_t way	= r_sc_way.read();
-                    size_t set	= m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())]; 
-                    size_t word	= m_x[(vci_addr_t)(m_cmd_sc_addr_fifo.read())]; 
+                    size_t way  = r_sc_way.read();
+                    size_t set  = m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
+                    size_t word = m_x[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
 
                     m_cache_data[way][set][word] = r_sc_wdata.read();
@@ -4321,9 +4711,9 @@
 
                     // monitor
-                    if ( m_monitor_ok ) 
-                    { 
+                    if ( m_monitor_ok )
+                    {
                         vci_addr_t address = m_cmd_sc_addr_fifo.read();
-		                char buf[80];
-		                snprintf(buf, 80, "SC_DIR_HIT_WRITE srcid %d", m_cmd_sc_srcid_fifo.read());
+                    char buf[80];
+                    snprintf(buf, 80, "SC_DIR_HIT_WRITE srcid %d", m_cmd_sc_srcid_fifo.read());
                         check_monitor( buf, address, r_sc_wdata.read() );
                         if ( r_sc_cpt.read()==4 )
@@ -4336,7 +4726,7 @@
 {
     std::cout << "  <MEMC " << name() << ".SC_BC_UPT_LOCK> Register a broadcast inval transaction in UPT"
-              << " / nline = " << nline 
-              << " / count = " << nb_copies 
-              << " / upt_index = " << index << std::endl; 
+              << " / nline = " << nline
+              << " / count = " << nb_copies
+              << " / upt_index = " << index << std::endl;
 }
 #endif
@@ -4358,11 +4748,11 @@
                 // set TRT
                 m_transaction_tab.set(r_sc_trt_index.read(),
-                                      false,		// PUT request to XRAM
+                                      false,    // PUT request to XRAM
                                       m_nline[(vci_addr_t)(m_cmd_sc_addr_fifo.read())],
                                       0,
                                       0,
                                       0,
-                                      false,		// not a processor read
-                                      0,  		
+                                      false,    // not a processor read
+                                      0,
                                       0,
                                       std::vector<be_t>(m_words,0),
@@ -4371,9 +4761,9 @@
                 // invalidate directory entry
                 DirectoryEntry entry;
-                entry.valid	        = false;
-                entry.dirty	        = false;
-                entry.tag	        = 0;
+                entry.valid         = false;
+                entry.dirty         = false;
+                entry.tag         = 0;
                 entry.is_cnt        = false;
-                entry.lock	        = false;
+                entry.lock          = false;
                 entry.count         = 0;
                 entry.owner.srcid   = 0;
@@ -4383,6 +4773,6 @@
                 entry.owner.inst    = false;
                 entry.ptr           = 0;
-                size_t set	        = m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
-                size_t way	        = r_sc_way.read();
+                size_t set          = m_y[(vci_addr_t)(m_cmd_sc_addr_fifo.read())];
+                size_t way          = r_sc_way.read();
                 m_cache_directory.write(set, way, entry);
 
@@ -4397,6 +4787,6 @@
 }
 #endif
-            } 
-            else 
+            }
+            else
             {
                 assert(false and "LOCK ERROR in SC_FSM, STATE = SC_BC_DIR_INVAL");
@@ -4408,5 +4798,5 @@
         {
             if ( !r_sc_to_init_cmd_multi_req.read() &&
-                 !r_sc_to_init_cmd_brdcast_req.read()) 
+                 !r_sc_to_init_cmd_brdcast_req.read())
             {
                 r_sc_to_init_cmd_multi_req    = false;
@@ -4424,5 +4814,5 @@
         case SC_BC_XRAM_REQ: // request the IXR FSM to start a put transaction
         {
-            if ( !r_sc_to_ixr_cmd_req ) 
+            if ( !r_sc_to_ixr_cmd_req )
             {
                 r_sc_to_ixr_cmd_req     = true;
@@ -4442,6 +4832,6 @@
 }
 #endif
-            } 
-            else 
+            }
+            else
             {
                std::cout << "MEM_CACHE, SC_BC_XRAM_REQ state : request should not have been previously set"
@@ -4453,13 +4843,13 @@
         case SC_RSP_FAIL:  // request TGT_RSP FSM to send a failure response
         {
-            if( !r_sc_to_tgt_rsp_req ) 
-            {
-                cmd_sc_fifo_get	    = true;
+            if( !r_sc_to_tgt_rsp_req )
+            {
+                cmd_sc_fifo_get     = true;
                 r_sc_cpt              = 0;
-                r_sc_to_tgt_rsp_req	= true;
-                r_sc_to_tgt_rsp_data	= 1;
-                r_sc_to_tgt_rsp_srcid	= m_cmd_sc_srcid_fifo.read();
-                r_sc_to_tgt_rsp_trdid	= m_cmd_sc_trdid_fifo.read();
-                r_sc_to_tgt_rsp_pktid	= m_cmd_sc_pktid_fifo.read();
+                r_sc_to_tgt_rsp_req = true;
+                r_sc_to_tgt_rsp_data  = 1;
+                r_sc_to_tgt_rsp_srcid = m_cmd_sc_srcid_fifo.read();
+                r_sc_to_tgt_rsp_trdid = m_cmd_sc_trdid_fifo.read();
+                r_sc_to_tgt_rsp_pktid = m_cmd_sc_pktid_fifo.read();
                 r_sc_fsm              = SC_IDLE;
 
@@ -4476,13 +4866,13 @@
         case SC_RSP_SUCCESS:  // request TGT_RSP FSM to send a success response
         {
-            if( !r_sc_to_tgt_rsp_req ) 
+            if( !r_sc_to_tgt_rsp_req )
             {
                 cmd_sc_fifo_get       = true;
                 r_sc_cpt              = 0;
-                r_sc_to_tgt_rsp_req	= true;
-                r_sc_to_tgt_rsp_data	= 0;
-                r_sc_to_tgt_rsp_srcid	= m_cmd_sc_srcid_fifo.read();
-                r_sc_to_tgt_rsp_trdid	= m_cmd_sc_trdid_fifo.read();
-                r_sc_to_tgt_rsp_pktid	= m_cmd_sc_pktid_fifo.read();
+                r_sc_to_tgt_rsp_req = true;
+                r_sc_to_tgt_rsp_data  = 0;
+                r_sc_to_tgt_rsp_srcid = m_cmd_sc_srcid_fifo.read();
+                r_sc_to_tgt_rsp_trdid = m_cmd_sc_trdid_fifo.read();
+                r_sc_to_tgt_rsp_pktid = m_cmd_sc_pktid_fifo.read();
                 r_sc_fsm              = SC_IDLE;
 
@@ -4499,5 +4889,5 @@
         case SC_MISS_TRT_LOCK:         // cache miss : request access to transaction Table
         {
-            if( r_alloc_trt_fsm.read() == ALLOC_TRT_SC ) 
+            if( r_alloc_trt_fsm.read() == ALLOC_TRT_SC )
             {
                 size_t   index = 0;
@@ -4511,8 +4901,8 @@
 if( m_debug_sc_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".SC_MISS_TRT_LOCK> Check TRT state" 
+    std::cout << "  <MEMC " << name() << ".SC_MISS_TRT_LOCK> Check TRT state"
               << " / hit_read = "  << hit_read
               << " / hit_write = " << hit_write
-              << " / wok = " << wok  
+              << " / wok = " << wok
               << " / index = " << index << std::endl;
 }
@@ -4522,6 +4912,6 @@
                 {
                     r_sc_fsm = SC_WAIT;
-                } 
-                else 
+                }
+                else
                 {
                     r_sc_trt_index = index;
@@ -4532,7 +4922,7 @@
         }
         ////////////////////
-        case SC_MISS_TRT_SET:	// register the GET transaction in TRT
-        {
-            if( r_alloc_trt_fsm.read() == ALLOC_TRT_SC ) 
+        case SC_MISS_TRT_SET: // register the GET transaction in TRT
+        {
+            if( r_alloc_trt_fsm.read() == ALLOC_TRT_SC )
             {
                 std::vector<be_t> be_vector;
@@ -4540,6 +4930,6 @@
                 be_vector.clear();
                 data_vector.clear();
-                for ( size_t i=0; i<m_words; i++ ) 
-                {   
+                for ( size_t i=0; i<m_words; i++ )
+                {
                     be_vector.push_back(0);
                     data_vector.push_back(0);
@@ -4547,15 +4937,15 @@
 
                 m_transaction_tab.set(r_sc_trt_index.read(),
-                                      true,		// read request		
+                                      true,   // read request
                                       m_nline[(vci_addr_t)m_cmd_sc_addr_fifo.read()],
                                       m_cmd_sc_srcid_fifo.read(),
                                       m_cmd_sc_trdid_fifo.read(),
                                       m_cmd_sc_pktid_fifo.read(),
-                                      false,		// write request from processor
+                                      false,    // write request from processor
                                       0,
                                       0,
                                       be_vector,
                                       data_vector);
-                r_sc_fsm = SC_MISS_XRAM_REQ;        
+                r_sc_fsm = SC_MISS_XRAM_REQ;
 
 #if DEBUG_MEMC_SC
@@ -4563,5 +4953,5 @@
 {
     std::cout << "  <MEMC " << name() << ".SC_MISS_TRT_SET> Register a GET transaction in TRT" << std::hex
-              << " / nline = " << m_nline[(vci_addr_t)m_cmd_sc_addr_fifo.read()] 
+              << " / nline = " << m_nline[(vci_addr_t)m_cmd_sc_addr_fifo.read()]
               << " / trt_index = " << r_sc_trt_index.read() << std::endl;
 }
@@ -4571,7 +4961,7 @@
         }
         //////////////////////
-        case SC_MISS_XRAM_REQ:	// request the IXR_CMD FSM to fetch the missing line
-        {
-            if ( !r_sc_to_ixr_cmd_req ) 
+        case SC_MISS_XRAM_REQ:  // request the IXR_CMD FSM to fetch the missing line
+        {
+            if ( !r_sc_to_ixr_cmd_req )
             {
                 r_sc_to_ixr_cmd_req        = true;
@@ -4596,5 +4986,5 @@
 
     //////////////////////////////////////////////////////////////////////////////
-    //		INIT_CMD FSM
+    //    INIT_CMD FSM
     //////////////////////////////////////////////////////////////////////////////
     // The INIT_CMD fsm controls the VCI CMD initiator port on the coherence
@@ -4603,52 +4993,52 @@
     // It implements a round-robin priority between the three possible client FSMs
     // XRAM_RSP, WRITE and SC. Each FSM can request two types of services:
-    // - r_xram_rsp_to_init_cmd_multi_req : multi-inval  
-    //   r_xram_rsp_to_init_cmd_brdcast_req : broadcast-inval  
-    // - r_write_to_init_cmd_multi_req : multi-update  
-    //   r_write_to_init_cmd_brdcast_req : broadcast-inval 
-    // - r_sc_to_init_cmd_multi_req : multi-update  
+    // - r_xram_rsp_to_init_cmd_multi_req : multi-inval
+    //   r_xram_rsp_to_init_cmd_brdcast_req : broadcast-inval
+    // - r_write_to_init_cmd_multi_req : multi-update
+    //   r_write_to_init_cmd_brdcast_req : broadcast-inval
+    // - r_sc_to_init_cmd_multi_req : multi-update
     //   r_sc_to_init_cmd_brdcast_req : broadcast-inval
     //
-    // An inval request is a single cell VCI write command containing the 
+    // An inval request is a single cell VCI write command containing the
     // index of the line to be invalidated.
-    // An update request is a multi-cells VCI write command : The first cell 
-    // contains the index of the cache line to be updated. The second cell contains 
+    // An update request is a multi-cells VCI write command : The first cell
+    // contains the index of the cache line to be updated. The second cell contains
     // the index of the first modified word in the line. The following cells
     // contain the data.
     ///////////////////////////////////////////////////////////////////////////////
 
-    switch ( r_init_cmd_fsm.read() ) 
+    switch ( r_init_cmd_fsm.read() )
     {
-        //////////////////////// 
-        case INIT_CMD_UPDT_IDLE:	// XRAM_RSP FSM has highest priority
+        ////////////////////////
+        case INIT_CMD_UPDT_IDLE:  // XRAM_RSP FSM has highest priority
         {
             if ( m_xram_rsp_to_init_cmd_inst_fifo.rok() ||
-                 r_xram_rsp_to_init_cmd_multi_req.read()  ) 
+                 r_xram_rsp_to_init_cmd_multi_req.read()  )
             {
                 r_init_cmd_fsm = INIT_CMD_INVAL_NLINE;
                 m_cpt_inval++;
-            } 
-            else if ( r_xram_rsp_to_init_cmd_brdcast_req.read() ) 
+            }
+            else if ( r_xram_rsp_to_init_cmd_brdcast_req.read() )
             {
                 r_init_cmd_fsm = INIT_CMD_XRAM_BRDCAST;
                 m_cpt_inval++;
-            } 
+            }
             else if ( m_write_to_init_cmd_inst_fifo.rok() ||
-                      r_write_to_init_cmd_multi_req.read() ) 
+                      r_write_to_init_cmd_multi_req.read() )
             {
                 r_init_cmd_fsm = INIT_CMD_UPDT_NLINE;
                 m_cpt_update++;
-            } 
+            }
             else if ( r_write_to_init_cmd_brdcast_req.read() )
             {
                 r_init_cmd_fsm = INIT_CMD_WRITE_BRDCAST;
                 m_cpt_inval++;
-            } 
+            }
             else if ( m_sc_to_init_cmd_inst_fifo.rok() ||
-                      r_sc_to_init_cmd_multi_req.read()  ) 
+                      r_sc_to_init_cmd_multi_req.read()  )
             {
                 r_init_cmd_fsm = INIT_CMD_SC_UPDT_NLINE;
                 m_cpt_update++;
-            } 
+            }
             else if( r_sc_to_init_cmd_brdcast_req.read() )
             {
